﻿Public Class Form1
    Public Const MAX_IMAGE_NO As Integer = 5
    Public Const MAX_COUNT As Integer = 30
    Public Const SPEED As Integer = 1000
    Private point As Integer
    Private count As Integer
    Private danceNo As Integer
    Private Str() As String = {"Space", "A", "S", "D", "F"}
    Private flg As Boolean
    Private WithEvents timer1 As Timer
    Private dance1 As DanceImage
    Private sound1 As EffectSound
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        timer1 = New Timer()
        timer1.Interval = SPEED
        dance1 = New DanceImage()
        sound1 = New EffectSound()
    End Sub
    Private Sub GameStart()
        point = 0
        count = 0
        Button1.Text = "ストップ"
        Label2.Text = "得点 0"
        timer1.Start()
        sound1.Play()
    End Sub
    Private Sub GameOver()
        Dim score As Integer = (point / MAX_COUNT) * 100
        Label1.Text = "得点率  " & score & "％"
        Button1.Text = "スタート"
        timer1.Stop()
        sound1.Stop()
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.MouseClick
        If Button1.Text = "スタート" Then
            GameStart()
        Else
            GameOver()
        End If
    End Sub
    Private Sub timer1_Tick(sender As Object, e As EventArgs) Handles timer1.Tick
        count = count + 1
        If count > MAX_COUNT Then
            GameOver()
        Else
            danceNo = New Random().Next(MAX_IMAGE_NO)
            Label1.Text = count.ToString & "回目 [" & Str(danceNo) & "]キー"
            flg = True
        End If
    End Sub
    Private Sub Judgment(sender As Object, e As KeyEventArgs) Handles Button1.KeyDown
        If Button1.Text = "ストップ" Then
            Dim KeyNo As Integer = -1
            Select Case e.KeyCode
                Case 32 : KeyNo = 0
                Case 65 : KeyNo = 1
                Case 83 : KeyNo = 2
                Case 68 : KeyNo = 3
                Case 70 : KeyNo = 4
            End Select
            dance1.Dancing(KeyNo)
            If flg And danceNo = KeyNo Then
                sound1.Correct()
                point = point + 1
                Label2.Text = "得点 " & point & "点"
            Else
                sound1.Incorrect()
            End If
            flg = False
        End If
    End Sub
End Class

Class EffectSound : Inherits System.Media.SoundPlayer
    Sub New()
        MyBase.New("..\..\Sample.wav")
    End Sub
    Sub Correct()
        Console.Beep(1000, 100)
    End Sub
    Sub Incorrect()
        Console.Beep(100, 100)
    End Sub
End Class

Class DanceImage
    Private DanceImage(Form1.MAX_IMAGE_NO) As Image
    Sub New()
        For i As Integer = 0 To (Form1.MAX_IMAGE_NO - 1)
            DanceImage(i) = Image.FromFile("..\..\Dance" & i & ".GIF")
        Next
        Form1.PictureBox1.Image = DanceImage(0)
    End Sub
    Sub Dancing(ByVal index As Integer)
        If index >= 0 And index < Form1.MAX_IMAGE_NO Then
            Form1.PictureBox1.Image = DanceImage(index)
        End If
    End Sub
End Class

