﻿Public Class Form1
    Friend operation1 As Operation
    Friend roulette1 As Roulette
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        operation1 = New Operation()
        roulette1 = New Roulette()
        Size = New Size(580, 300)
        Text = "すしルーレット"
    End Sub
End Class
Enum Neta
    Uni_Ikura
    Toro_Maguro
    Ebi_Ika
End Enum
Class Roulette
    Private Const SPEED1 As Integer = 300
    Private Const SPEED2 As Integer = 800
    Private Const INERTIA_MIN As Integer = 2
    Private Const INERTIA_MAX As Integer = 5
    Private Const PICTURE_NO As Integer = 5
    Private picturePoint() As Point = {New Point(104, 12), New Point(196, 40), New Point(196, 133), New Point(104, 170),
    New Point(12, 133), New Point(12, 40)}
    Private pictureSize As Size = New Size(86, 86)
    Private pb(PICTURE_NO) As PictureBox
    Private count As Integer
    Private inertia As Integer
    Private WithEvents timer1 As Timer
    Sub New()
        For i As Integer = 0 To pb.Length - 1
            pb(i) = New PictureBox
            pb(i).Location = picturePoint(i)
            pb(i).Size = pictureSize
            pb(i).SizeMode = PictureBoxSizeMode.CenterImage
            Try
                pb(i).Image = Image.FromFile("..\..\Sushi" & i & ".GIF")
            Catch ex As System.IO.FileNotFoundException
                MessageBox.Show(ex.ToString(), "画像ファイルが見つかりません。")
                End
            End Try
            Form1.Controls.Add(pb(i))
        Next
        timer1 = New Timer()
        inertia = -1
    End Sub
    Sub Rotation()
        timer1.Interval = SPEED1
        timer1.Start()
    End Sub
    Sub RotationStop()
        inertia = New Random().Next(INERTIA_MIN, INERTIA_MAX)
        timer1.Interval = SPEED2
    End Sub
    Private Sub timer1_Tick(sender As Object, e As EventArgs) Handles timer1.Tick
        pb(count).BackColor = Color.Yellow
        If count = 0 Then
            pb(PICTURE_NO).BackColor = Form1.BackColor
        Else
            pb(count - 1).BackColor = Form1.BackColor
        End If
        count = (count + 1) Mod (PICTURE_NO + 1)
        If inertia > 0 Then
            inertia = inertia - 1
        ElseIf inertia = 0 Then
            inertia = -1
            timer1.Stop()
            Form1.operation1.GameOver(count)
        End If
    End Sub
End Class
Class Operation
    Private msgLabel As Label
    Private msgLabelPoint As Point = New Point(350, 40)
    Private betButton(2) As Button
    Private betButtonPoint() As Point = {New Point(300, 110), New Point(380, 110), New Point(460, 110)}
    Private betButtonSize As Size = New Size(80, 23)
    Private betButtonText() As String = {"うに.いくら", "中トロ・マグロ", "エビ.イカ"}
    Private gameButton(1) As Button
    Private gameButtonPoint() As Point = {New Point(333, 159), New Point(434, 159)}
    Private gameButtonSize As Size = New Size(70, 23)
    Private gameButtonText() As String = {"スタート", "ストップ"}
    Private bet As Integer
    Sub New()
        msgLabel = New Label()
        msgLabel.Location = msgLabelPoint
        msgLabel.AutoSize = True
        msgLabel.Text = "どれに賭けますか？"
        Form1.Controls.Add(msgLabel)
        For i As Integer = 0 To betButton.Length - 1
            betButton(i) = New Button()
            betButton(i).Location = betButtonPoint(i)
            betButton(i).Size = betButtonSize
            betButton(i).Text = betButtonText(i)
            Form1.Controls.Add(betButton(i))
            AddHandler betButton(i).Click, AddressOf betButton_Click
        Next
        For i As Integer = 0 To gameButton.Length - 1
            gameButton(i) = New Button()
            gameButton(i).Location = gameButtonPoint(i)
            gameButton(i).Size = gameButtonSize
            gameButton(i).Text = gameButtonText(i)
            gameButton(i).Enabled = False
            Form1.Controls.Add(gameButton(i))
            AddHandler gameButton(i).Click, AddressOf gameButton_Click
        Next
    End Sub
    Private Sub betButton_Click(sender As System.Object, e As System.EventArgs)
        If sender Is betButton(0) Then
            bet = Neta.Uni_Ikura
            msgLabel.Text = "うに・いくらに賭けました！"
        ElseIf sender Is betButton(1) Then
            bet = Neta.Toro_Maguro
            msgLabel.Text = "中トロ・マグロに賭けました！"
        ElseIf sender Is betButton(2) Then
            bet = Neta.Ebi_Ika
            msgLabel.Text = "エビ・イカに賭けました！"
        End If
        gameButton(0).Enabled = True
    End Sub
    Private Sub gameButton_Click(sender As System.Object, e As System.EventArgs)
        If sender Is gameButton(0) Then
            For Each b As Button In betButton
                b.Enabled = False
            Next
            gameButton(0).Enabled = False
            gameButton(1).Enabled = True
            Form1.roulette1.Rotation()
        ElseIf sender Is gameButton(1) Then
            gameButton(1).Enabled = False
            Form1.roulette1.RotationStop()
        End If
    End Sub
    Sub GameOver(count As Integer)
        If (count = 1 Or count = 2) And bet = Neta.Uni_Ikura Then
            msgLabel.Text = "うに・いくら、当たりました！！"
        ElseIf (count = 4 Or count = 5) And bet = Neta.Toro_Maguro Then
            msgLabel.Text = "中トロ・マグロ、当たりました！！"
        ElseIf (count = 3 Or count = 0) And bet = Neta.Ebi_Ika Then
            msgLabel.Text = "エビ・イカ、当たりました！！"
        Else
            msgLabel.Text = "残念！！どれに賭けますか？"
        End If
        For i As Integer = 0 To betButton.Length - 1
            betButton(i).Enabled = True
        Next
    End Sub
End Class